package org.ksv.plugin;

import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.swt.dnd.Clipboard;
import org.eclipse.swt.dnd.TextTransfer;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.IWorkbenchWindowActionDelegate;
import org.eclipse.ui.PlatformUI;

import com.openedge.pdt.text.OEProject;

/**
 * Opens files in the editor taking the list of the file from clipboard
 * @author ksv
 *
 */
public class OpenFromClipboard implements IWorkbenchWindowActionDelegate, IKsvPlugin{

	private IWorkbenchWindow window;
	
	public void dispose() {
		// TODO Auto-generated method stub		
	}

	public void init( IWorkbenchWindow window ) {
		this.window = window;
		
	}

	public void run( IAction action ) {
		KsvUtils.runPlugin( this );		
	}
	
	public void selectionChanged( IAction action, ISelection selection ) {		
	}

	/**
	 * Opens files in the editor taking the list of the file from clipboard
	 * @param project - current OpenEdge project
	 */
	public void runAction( OEProject project ) {
		// Get current display
		IWorkbench workbench = PlatformUI.getWorkbench( );
		if ( workbench == null ) return;
		// Get data from clipboard 
		Clipboard cp = new Clipboard( workbench.getDisplay( ) );
		String fileList = ( String ) cp.getContents( TextTransfer.getInstance( ) );
		// Open files
		String[] files = fileList.split( "\n" );
		for ( int i = 0; i < files.length; i++ ) {
			String fname = files[i];
			fname = fname.replace( "\"", "" );
			fname = fname.replace( "'", "" );
			fname = fname.replace( "{", "" );
			fname = fname.replace( "}", "" );
			fname = fname.replace( "[", "" );
			fname = fname.replace( "]", "" );
			fname = fname.trim();
			if ( !fname.equals( "" ) ) {
				KsvUtils.openFileInPropath( fname, project, true, window );
			}
		}
			
	}

}
