package org.ksv.plugin;

import java.io.File;

import org.eclipse.jface.action.IAction;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.IWorkbenchWindowActionDelegate;

import com.openedge.pdt.text.OEProject;

/**
 * Gets an original filename for the current file
 * Current file might've been copied from somewhere
 * and this class tries to get its original name  
 * @author ksv
 *
 */
public class OriginalFile implements IWorkbenchWindowActionDelegate, IKsvPlugin{

	private IWorkbenchWindow window;
	
	public void dispose() {
		// TODO Auto-generated method stub		
	}

	public void init(IWorkbenchWindow window) {
		this.window = window;
		
	}

	public void run(IAction action) {
		KsvUtils.runPlugin(this);		
	}
	
	public void selectionChanged(IAction action, ISelection selection) {		
	}

	/**
	 * Copies the current file into the current OE Project 
	 */
	public void runAction(OEProject project) {
		
		// Get the current file opened in the editor
		File file = KsvUtils.getEditorFile(window);
		
		// If file is ok, try to get its original name
		if (file != null && file.exists()) {
			File origFile = CopyHistory.getFromCopyHistory( file );
			// It was really copied, ask a user to open it
			if ( origFile != null && origFile.exists() ) {
				boolean choice = MessageDialog.openQuestion(
						window.getShell(), 
						"KsvPlugin", 
						"File was copied from [ " + origFile.getAbsolutePath() + " ].\n\n" +
				"Do you want to open it?");
				// Open the file
				if ( choice ) {
					KsvUtils.openFileInEditor( origFile );
				}
			}
			
		}	
	}

}
